import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/**
 * Clase FileFilterNQC
 * Esta clase permite indicar los archivos que terminan en ".nqc".
 * 
 * @author Patricio A. Castillo Pizarro - Eric C. Maldonado Olguin
 * @version 1.0 - June 16th, 2007
 */
public class FileFilterNQC extends FileFilter {

    /**
     * Indica si la extension del archivo es ".nqc"
     */
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }
        
        String file = f.getName();
        int i = file.lastIndexOf(".");
        if ( (i>0) && (i<file.length()-1) ) {
            String ext = file.substring(i+1).toLowerCase();
            if ( 0 == ext.compareTo("nqc") )
                return true;
            else
                return false;
        }else
            return false;
    }

    /**
     * Descriptor del filtro
     */
    public String getDescription() {
        return "archivos NQC - Not Quite C";
    }
}
// Fin Clase FileFilterNQC
