import java.awt.event.*;
import java.awt.*;
import java.io.*;
import javax.swing.*;

/**
 * Clase HandlerObjetoEvento
 * Permite importar un bloque "Evento" al programa.
 * @author Patricio A. Castillo Pizarro - Eric C. Maldonado Olguin
 * @version 1.0 - Jun 26th, 2007
 */
class HandlerObjetoCondicion implements ActionListener
{
    private EditorPanel panel;
    private ObjetoCondicion condicion;
    private String tipoCondicion;
   
    
    /**
     * Constructor.
     * @param p Panel en que se encuentra el programa grafico a compilar
     */
    public HandlerObjetoCondicion(EditorPanel p)
    {
        panel = p;
    }
    
     public void actionPerformed(ActionEvent e) {
        tipoCondicion = e.getActionCommand();
        condicion = new ObjetoCondicion (400,200);
        
        //Setea los parametros del bloque de acuerdo al menu desde el que fue creado.
        if(tipoCondicion.equals("SiNo")) {
            condicion.nombreObjeto = tipoCondicion;
            condicion.sensor = "SENSOR_1";
            condicion.type = "SENSOR_LIGHT";
            condicion.condicion = "SENSOR_1<50";
        }
        if(tipoCondicion.equals("RepetirMientras")) {
            condicion.nombreObjeto = tipoCondicion;
            condicion.sensor = "SENSOR_1";
            condicion.type = "SENSOR_LIGHT";
            condicion.condicion = "SENSOR_1<50";
            ObjetoCondicion condicionfin = new ObjetoCondicion (400,250);
            condicionfin.nombreObjeto = "CondicionFin";
            panel.incorpore (condicionfin);
        }
        if(tipoCondicion.equals("RepetirN")) {
            condicion.nombreObjeto = tipoCondicion;
            condicion.veces = 2;
            ObjetoCondicion condicionfin = new ObjetoCondicion (400,250);
            condicionfin.nombreObjeto = "CondicionFin";
            panel.incorpore (condicionfin);
        }
        if(tipoCondicion.equals("RepetirSiempre")) {
            condicion.nombreObjeto = tipoCondicion;
            ObjetoCondicion condicionfin = new ObjetoCondicion (400,250);
            condicionfin.nombreObjeto = "CondicionFin";
            panel.incorpore (condicionfin);
        }
        
        panel.incorpore (condicion);
    }
}
//Fin clase HandlerObjetoCondicion
