import java.awt.event.*;
import java.awt.*;
import java.io.*;
import javax.swing.*;

/**
 * Clase MenuArchivoImportar
 * Permite importar un archivo con codigo nqc.
 * @author Patricio A. Castillo Pizarro - Eric C. Maldonado Olguin
 * @version 1.2 - Jun 24th, 2007
 */
class MenuArchivoImportar implements MouseListener
{
    private EditorPanel panel;
    
    /**
     * Constructor.
     * @param p Panel en que se encuentra el programa grafico a compilar
     */
    public MenuArchivoImportar(EditorPanel p)
    {
        panel = p;
    }
    
    /**
     *Metodo que define las acciones a realizar al presiona el boton del mouse
     *@param event Parametro que indica la accion realizada por el mouse
     */
    public void mousePressed(MouseEvent event){
        //Este codigo permite escoger el archivo
        JFileChooser fcOpen = new JFileChooser();
        fcOpen.setSelectedFile(new File("*.nqc"));
        fcOpen.setFileFilter(new FileFilterNQC());
        int return_fcOpen = fcOpen.showOpenDialog(null);
        if (return_fcOpen == JFileChooser.APPROVE_OPTION) {
            File fileForOpen = fcOpen.getSelectedFile();
            String archivoAbre = fileForOpen.getAbsolutePath();
            
            //Este codigo permite leer el codigo del archivo.
            try {
                BufferedReader entrada =
                        new BufferedReader(new FileReader(archivoAbre));
                String linea = entrada.readLine();
                String leido = new String();
                while (linea != null){
                    leido = leido + linea + "\n";
                    linea = entrada.readLine();
                }
                entrada.close();
                ObjetoEvento nqc = new ObjetoEvento(400,200);
                nqc.nombreObjeto = "NQCPersonal";
                nqc.nqc = leido;
                panel.panelOUT = leido;
                panel.incorpore(nqc);
            } catch (IOException e) {
                System.out.println("No se puede leer el archivo");
                JOptionPane.showMessageDialog(null,
                    "No se puede leer el archivo.",
                    "Error", JOptionPane.ERROR_MESSAGE);
            }
        }
    }
    
    /**
     *Implementacion de MouseListener cuando el boton del mouse hace click
     */
    public void mouseClicked(MouseEvent event){}

    /**
     *Implementacion de MouseListener cuando el boton del mouse se libera
     */
    public void mouseReleased(MouseEvent event){}

    /**
     *Implementacion de MouseListener cuando el mouse ingresa a un componente
     */
    public void mouseEntered(MouseEvent event){}

    /**
     *Implementacion de MouseListener cuando el mouse sale de un componente
     */
    public void mouseExited(MouseEvent event){}
}
//Fin clase MenuArchivoImportar
