import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.io.IOException;
import java.io.InputStream;
import javax.swing.*;

/**
 * Clase MenuProgramaCorrer
 * Permite hacer correr el programa almacenado en el slot indicado.
 * @author Patricio A. Castillo Pizarro - Eric C. Maldonado Olguin
 * @version 1.2 - Jun 24th, 2007
 */
class MenuProgramaCorrer implements MouseListener
{
    private EditorPanel panel;
    
    /**
     * Constructor.
     * @param p Panel en que se encuentra el programa grafico a compilar
     */
    public MenuProgramaCorrer(EditorPanel p)
    {
        panel = p;
    }
    
    /**
     *Metodo que define las acciones a realizar al presiona el boton del mouse
     *@param event Parametro que indica la accion realizada por el mouse
     */
    public void mousePressed(MouseEvent event){
        //Primero se verifica que este presente el compilador.
        String compiler = new String();
        String sls = System.getProperty("file.separator");
        try{
            String path = new File(".").getCanonicalPath();
            compiler = path+sls+"nqc.exe";
            if (!new File(compiler).exists()){
                JOptionPane.showMessageDialog(null,
                        "No se encuentra el programa interfaz.\nAsegurese que "
                        +"\"nqc.exe\" se encuentra en la ruta desde la que se "
                        +"esta ejecutando esta aplicacion:\n"+path,
                        "Error", JOptionPane.ERROR_MESSAGE);
            }
        }catch (IOException e) {
            e.printStackTrace();
        }
        
        if (new File(compiler).exists()){
            boolean hecho = true;
            //Se procede a setear el numero de programa en el robot.
            try{
                String setpgm ="\""+compiler+"\" -T"+panel.tipo+" -S"+
                        panel.puerto+" -E -pgm "+panel.slot;
                Runtime run = Runtime.getRuntime();
                String line;
                BufferedReader input = new BufferedReader
                        (new InputStreamReader(
                        run.exec(setpgm).getInputStream()));
                panel.panelOUT = new String();
                while ((line = input.readLine()) != null) {
                    System.out.println(line);
                    panel.panelOUT = panel.panelOUT + line;
                    hecho = false;
                }
                input.close();
            } catch (Exception e){
                System.out.println("No es posible comunicarse con el RCX");
                JOptionPane.showMessageDialog(null,
                        "No es posible comunicarse con el RCX.\n" +
                        "Verifique que el robot este encendido y que las " +
                        "opciones sean correctas.",
                        "Error", JOptionPane.ERROR_MESSAGE);
            }
            
            //Se procede a hacer correr el programa en el robot.
            if (hecho){
                try{
                    String command="\""+compiler+"\" -T"+panel.tipo+" -S"+
                            panel.puerto+" -E -run";
                    Runtime run = Runtime.getRuntime();
                    String line;
                    BufferedReader input = new BufferedReader
                            (new InputStreamReader(
                            run.exec(command).getInputStream()));
                    while ((line = input.readLine()) != null) {
                        System.out.println(line);
                        panel.panelOUT = panel.panelOUT + line;
                    }
                    input.close();
                } catch (Exception e){
                    System.out.println("No es posible comunicarse con el RCX");
                    JOptionPane.showMessageDialog(null,
                            "No es posible comunicarse con el RCX.\n" +
                            "Verifique el programa de interfaz, que el robot " +
                            "este encendido y que las opciones sean correctas.",
                            "Error", JOptionPane.ERROR_MESSAGE);
                }
            }else{
                System.out.println("No es posible comunicarse con el RCX");
                JOptionPane.showMessageDialog(null,
                        "No es posible comunicarse con el RCX.\n" +
                        "\nVerifique el programa de interfaz, que el robot " +
                        "este encendido y que las opciones sean correctas.",
                        "Error", JOptionPane.ERROR_MESSAGE);
            }
        }
    }
    
    /**
     *Implementacion de MouseListener cuando el boton del mouse hace click
     */
    public void mouseClicked(MouseEvent event){}

    /**
     * Implementacion de MouseListener cuando el boton del mouse se libera.
     */
    public void mouseReleased(MouseEvent event){}

    /**
     * Implementacion de MouseListener cuando el mouse ingresa a un componente.
     */
    public void mouseEntered(MouseEvent event){}

    /**
     * Implementacion de MouseListener cuando el mouse sale de un componente.
     */
    public void mouseExited(MouseEvent event){}
}
//Fin clase MenuProgramaCorrer