import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.io.IOException;
import java.io.InputStream;
import javax.swing.*;
import java.util.*;

/**
 * Clase MenuRobotPrueba
 * Permite verificar la correcta comunicacion con el robot.
 * @author Patricio A. Castillo Pizarro - Eric C. Maldonado Olguin
 * @version 1.0 - Jun 24th, 2007
 */
class MenuRobotPrueba implements MouseListener
{
    private EditorPanel panel;
    
    /**
     * Constructor.
     * @param p Panel en que se encuentra el programa grafico a compilar
     */
    public MenuRobotPrueba(EditorPanel p)
    {
        panel = p;
    }
    
    /**
     *Metodo que define las acciones a realizar al presiona el boton del mouse
     *@param event Parametro que indica la accion realizada por el mouse
     */
    public void mousePressed(MouseEvent event){
        //Primero se verifica que este presente el compilador.
        String compiler = new String();
        String sls = System.getProperty("file.separator");
        try{
            String path = new File(".").getCanonicalPath();
            compiler = path+sls+"nqc.exe";
            if (!new File(compiler).exists()){
                JOptionPane.showMessageDialog(null,
                        "No se encuentra el programa interfaz.\nAsegurese que "
                        +"\"nqc.exe\" se encuentra en la ruta desde la que se "
                        +"esta ejecutando esta aplicacion:\n"+path,
                        "Error", JOptionPane.ERROR_MESSAGE);
            }
        }catch (IOException e) {
            e.printStackTrace();
        }
        
        if (new File(compiler).exists()){
            //Se procede a enviar una senal para que el robot emita un sonido.
            try{
                boolean hecho = true;
                String command ="\""+compiler+"\" -T"+panel.tipo+" -S"+
                        panel.puerto+" -raw 5102";
                Runtime run = Runtime.getRuntime();
                String line = new String();
                BufferedReader input = new BufferedReader
                        (new InputStreamReader(
                        run.exec(command).getInputStream()));
                panel.panelOUT = new String();
                while ((line = input.readLine()) != null) {
                    System.out.println(line);
                    panel.panelOUT = panel.panelOUT + line;
                    hecho = false;
                }
                input.close();
                if (!hecho)
                    JOptionPane.showMessageDialog(null,
                        "No es posible comunicarse con el RCX.\n" +
                        "Verifique que el robot este encendido y que las " +
                        "opciones sean correctas.",
                        "Error", JOptionPane.ERROR_MESSAGE);
            } catch (Exception e){
                System.out.println("No es posible comunicarse con el RCX");
                JOptionPane.showMessageDialog(null,
                        "No es posible comunicarse con el RCX.\n" +
                        "Verifique que el robot este encendido y que las " +
                        "opciones sean correctas.",
                        "Error", JOptionPane.ERROR_MESSAGE);
            }
        }
    }
    
    /**
     *Implementacion de MouseListener cuando el boton del mouse hace click
     */
    public void mouseClicked(MouseEvent event){}

    /**
     * Implementacion de MouseListener cuando el boton del mouse se libera.
     */
    public void mouseReleased(MouseEvent event){}

    /**
     * Implementacion de MouseListener cuando el mouse ingresa a un componente.
     */
    public void mouseEntered(MouseEvent event){}

    /**
     * Implementacion de MouseListener cuando el mouse sale de un componente.
     */
    public void mouseExited(MouseEvent event){}
}
//Fin clase MenuRobotPrueba